var _excluded = ["container", "children"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Fragment, forwardRef, useRef, useImperativeHandle, useEffect, useState } from 'react';
import Instance from "./instance.js";
var IndexBar = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var container = _ref.container,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      anchors = _useState2[0],
      setAnchors = _useState2[1]; // 节点


  var rootRef = useRef(null);
  var tooltipRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      tooltipDOM: tooltipRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getTooltipDOM: function getTooltipDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  useEffect(function () {
    // 实例化
    initInstance(); // eslint-disable-next-line
  }, []);
  useEffect(function () {
    // 更新锚记
    updateAnchors(); // eslint-disable-next-line
  }, [children]); // 实例化

  function initInstance() {
    instance.current = new Instance({
      overflowContainer: container,
      container: rootRef.current,
      tooltipContainer: tooltipRef.current
    }); // 更新锚记

    updateAnchors();
  } // 获取所有锚点


  function updateAnchors() {
    if (!instance.current || !instance.current.getAnchors) return;
    console.log('updateAnchors');
    anchors = instance.current.getAnchors();
    setAnchors(anchors);
  }

  var DOM = /*#__PURE__*/React.createElement(Fragment, null, children, /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef
  }, props, {
    className: "indexbar".concat(props.className ? ' ' + props.className : '')
  }), (anchors || []).map(function (anchor, i) {
    return /*#__PURE__*/React.createElement("span", {
      className: "indexbar-button",
      "data-indexbar-link": anchor,
      key: "btn".concat(i)
    }, /*#__PURE__*/React.createElement("span", {
      className: "indexbar-button-caption"
    }, anchor));
  })), /*#__PURE__*/React.createElement("div", {
    ref: tooltipRef,
    className: "indexbar-tooltip"
  }));
  return DOM;
});
export default IndexBar;