var _excluded = ["value", "list", "onChange", "onExpand", "onCollapse", "searchProps", "throttle", "itemRender"],
    _excluded2 = ["visible", "value", "onSearch"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// require PrototypeArray.js
import React, { forwardRef, useRef, useState, useImperativeHandle } from 'react';
import Input from "./../../Input";
import Tree from "./Tree";
import locale from "./../../locale"; // 国际化
// 树菜单选择

var Menu = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      _ref$list = _ref.list,
      list = _ref$list === void 0 ? [] : _ref$list,
      onChange = _ref.onChange,
      onExpand = _ref.onExpand,
      onCollapse = _ref.onCollapse,
      searchProps = _ref.searchProps,
      _ref$throttle = _ref.throttle,
      throttle = _ref$throttle === void 0 ? 500 : _ref$throttle,
      itemRender = _ref.itemRender,
      props = _objectWithoutProperties(_ref, _excluded);

  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    var _rootRef$current;

    return {
      rootDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.current,
      getRootDOM: function getRootDOM() {
        var _rootRef$current2;

        return rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current2 = rootRef.current) === null || _rootRef$current2 === void 0 ? void 0 : _rootRef$current2.current;
      }
    };
  }); // 搜索项属性

  var _ref2 = searchProps || {},
      searchVisible = _ref2.visible,
      searchValue = _ref2.value,
      onSearch = _ref2.onSearch,
      otherSearchProps = _objectWithoutProperties(_ref2, _excluded2);

  var _useState = useState(searchValue),
      _useState2 = _slicedToArray(_useState, 2),
      keyword = _useState2[0],
      setKeyword = _useState2[1];

  function handleSearch(newKeyword) {
    // 节流搜索
    if (window.timeout) {
      window.clearTimeout(window.timeout);
    }

    window.timeout = window.setTimeout(function () {
      keyword = newKeyword;
      setKeyword(newKeyword);
      if (onSearch) onSearch(keyword);
    }, throttle);
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, searchVisible && /*#__PURE__*/React.createElement(Input.Text, _extends({
    placeholder: locale('搜索', 'input_search_placeholder'),
    onChange: handleSearch,
    className: "treepicker-search-input",
    defaultValue: keyword,
    allowClear: true
  }, otherSearchProps)), /*#__PURE__*/React.createElement(Tree, _extends({
    ref: rootRef,
    itemRender: itemRender,
    keyword: keyword,
    value: value,
    list: list,
    onChange: onChange,
    onExpand: onExpand,
    onCollapse: onCollapse
  }, props)));
});
export default Menu;