var _excluded = ["multiple", "checkStrictly", "checkable", "selectable", "list", "defaultValue", "value", "searchProps", "throttle", "onChange", "showIcon", "itemRender"],
    _excluded2 = ["visible", "value", "onSearch"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useMemo, useState, useRef } from 'react';
import Tree from 'rc-tree';
import Input from "../../Input";
import Utils from "./Utils";
import locale from "./../../locale"; // 国际化
// 树控件

function TreePicker(_ref) {
  var multiple = _ref.multiple,
      _ref$checkStrictly = _ref.checkStrictly,
      checkStrictly = _ref$checkStrictly === void 0 ? false : _ref$checkStrictly,
      _ref$checkable = _ref.checkable,
      checkable = _ref$checkable === void 0 ? true : _ref$checkable,
      selectable = _ref.selectable,
      list = _ref.list,
      defaultValue = _ref.defaultValue,
      value = _ref.value,
      searchProps = _ref.searchProps,
      _ref$throttle = _ref.throttle,
      throttle = _ref$throttle === void 0 ? 500 : _ref$throttle,
      onChange = _ref.onChange,
      _ref$showIcon = _ref.showIcon,
      showIcon = _ref$showIcon === void 0 ? false : _ref$showIcon,
      itemRender = _ref.itemRender,
      props = _objectWithoutProperties(_ref, _excluded);

  // 扁平化数据, 搜索时需要展开的子级
  var flattenListRef = useRef(Array.isArray(list) && list.length ? Object.clone(list).flattenTree() : []);
  useEffect(function () {
    // 第一次不走
    if (!flattenListRef.current.isFirst) {
      flattenListRef.current.isFirst = true;
    } // 第二次开始更新
    else {
      if (Array.isArray(list) && list.length) {
        flattenListRef.current = Object.clone(list).flattenTree();
      }
    } // 展开关键字


    handleExpandedKeys(); // eslint-disable-next-line
  }, [list]); // 展开的id

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      expandedKeys = _useState2[0],
      setExpandedKeys = _useState2[1]; // 选中子级时自动展开父级, 但为设为自动true时无法收缩, 所以收缩时需要再设为false(expandedKeys如果带入了父级则不需要自动展开父级)
  // const [autoExpandParent, setAutoExpandParent] = useState(true) // autoExpandParent此属性会引发卡顿, 不建议使用


  var handleExpand = function handleExpand(newExpandedKeys) {
    setExpandedKeys(newExpandedKeys); // setAutoExpandParent(false)
  }; // 搜索项属性


  var _ref2 = searchProps || {},
      searchVisible = _ref2.visible,
      searchValue = _ref2.value,
      onSearch = _ref2.onSearch,
      otherSearchProps = _objectWithoutProperties(_ref2, _excluded2); // 搜索


  var _useState3 = useState(searchValue),
      _useState4 = _slicedToArray(_useState3, 2),
      keyword = _useState4[0],
      setKeyword = _useState4[1];

  function handleSearch(newKeyword) {
    keyword = newKeyword;
    setKeyword(newKeyword); // 节流搜索

    if (window.timeout) {
      window.clearTimeout(window.timeout);
    }

    window.timeout = window.setTimeout(function () {
      handleExpandedKeys();
      if (onSearch) onSearch(keyword);
    }, throttle);
  } // 展开keys属性


  var expandProp = searchVisible ? {
    // 点击展开(expandedKeys如果带入了父级则不需要自动展开父级)
    onExpand: handleExpand,
    // autoExpandParent: autoExpandParent,
    // 搜索时展开的子级
    expandedKeys: expandedKeys
  } : {}; // 展开关键字

  function handleExpandedKeys() {
    // 没有关键字则没有展开项
    if (!keyword || Object.isEmptyObject(list)) {
      setExpandedKeys([]);
    } else {
      // 展开的keys
      var newExpandedKeys = Utils.getExpandedKeys(keyword, flattenListRef.current);
      setExpandedKeys(newExpandedKeys); // setAutoExpandParent(true)
    }
  } // 修改


  function handleChange(ids, checkedObject) {
    var checkedNodes = (checkedObject === null || checkedObject === void 0 ? void 0 : checkedObject.checkedNodes) || []; // 单选只选中当前项

    if (!multiple) {
      checkedNodes = checkedObject !== null && checkedObject !== void 0 && checkedObject.node ? [checkedObject === null || checkedObject === void 0 ? void 0 : checkedObject.node] : []; // 如果已经选中, 则清空

      if (checkedNodes.length && checkedNodes.length === 1 && Array.isArray(value) && value.length && value.length === 1) {
        if (checkedNodes[0].id === value[0].id) {
          checkedNodes = [];
        }
      }
    }

    if (onChange) onChange(checkedNodes);
  } // 构建渲染数据, 支持关键字搜索


  var treeData = Utils.getTreeData({
    list: list,
    keyword: keyword,
    itemRender: itemRender
  }); // 构建选中项

  var checkedKeysProp = useMemo(function () {
    return Utils.getCheckedKeysProp(value, defaultValue);
  }, [value, defaultValue]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, searchVisible && /*#__PURE__*/React.createElement(Input.Text, _extends({
    placeholder: locale('搜索', 'input_search_placeholder'),
    onChange: handleSearch,
    className: "treepicker-search-input",
    defaultValue: keyword,
    allowClear: true
  }, otherSearchProps)), /*#__PURE__*/React.createElement(Tree, _extends({
    fieldNames: {
      key: 'id'
    },
    treeData: treeData,
    multiple: multiple // 选中项属性

  }, checkedKeysProp, {
    // 选中checkbox
    onCheck: handleChange // 点击
    ,
    onSelect: handleChange // 展开keys属性

  }, expandProp, {
    // 树默认设置
    showIcon: showIcon,
    checkStrictly: checkStrictly,
    checkable: checkable,
    selectable: checkable ? false : true
  }, props)));
}

export default TreePicker;